
//********************************************************************
//  Simulategame.java       Author: Ryo (Rio) Akasaka
//  
//  Last modified: Wed Jan 24 22:15
//
//  Description: Simulates n games of world-series type playoffs, 
//  where n, the number of games in a series, and the probability 
//  that team A wins is provided by the user.
//
//********************************************************************

import java.util.Scanner;
import java.util.Random;

public class Simulategame
{
  public static void main (String[] args)
   {
      int numseries, numgames;
      double probability;
      int count = 0, acounter = 0, sum = 0;
      int awinNumber=0, bwinNumber=0, gamecounter=0;
 
      Scanner value = new Scanner (System.in);

      System.out.print ("This program will simulate a number of \n"+
			"world-series-like playoffs. You may supply\n"+ 
			"the number of series to simulate, the number\n"+ 
			"of games it takes to win a series,\n"+
			"and the probablility that team A beats team B\n");

      System.out.print ("\n1. How many series should we simulate (1-100000)? ");
      numseries = value.nextInt();
      System.out.print ("2. How many games to win one series (1-5)? ");
      numgames = value.nextInt();
      System.out.print ("3. In any single game, what is the\n"+
			"   probability that team A beats team B? ");
      probability = value.nextDouble();

      // Creates array that will contain the length, A wins, B wins
      int [ ] array = new int [ numgames * 3 ];
      
      while (count != numseries) {

	awinNumber = bwinNumber = gamecounter = 0;

	// Plays games so long as series is not won
	while (awinNumber < numgames && bwinNumber < numgames) {

	  double gameresult = Math.random();
	  if (probability > gameresult) awinNumber++;
	  else bwinNumber++;
	  gamecounter++;

	}
	
	// Team A wins this series
	if (awinNumber > bwinNumber) {
	  
	  acounter++;
	
	  // Array for series length
	  array[gamecounter - numgames] = gamecounter;
	  
	  // Array for number of wins for that length
	  array[gamecounter]++;
	
	}
	else {

	  // Update team B information
	  array[gamecounter - numgames] = gamecounter;
	  array[gamecounter + numgames]++;
	}
	
	count ++;
          
      }
      
      System.out.println ("\nA won " + acounter + " series");
      System.out.println ("B won " + (numseries - acounter) + " series\n");
      System.out.println ("Here is a table showing series length,\n"+
			     "number of series of that length in the\n"+
			     "simulation, and for each series length,\n"+
			     "the number of each team's wins in that length series.\n");
      System.out.println ("length       number       awins       bwins");
      for (int index=0;index<array.length-numgames*2; index++) {

	sum += array[index+numgames];
	sum += array[index+numgames*2];
	System.out.println("   " + array[index] + "         "
			   + sum + "        "
			   + array[index+numgames]+ "       "
			   + array[index+numgames*2]);
	sum = 0;
	
      }

      System.out.println ();

   }
}
